<?php


namespace Schaffen\Financial\FinancialMovement\Models;


use Illuminate\Database\Eloquent\Model;

class Installment extends Model
{
    protected $table = "financeiro.parcela";
    protected $primaryKey = "par_codigo";
    protected $fillable = ["par_codigo", "par_fk_mvf_codigo", "par_data_vencimento_original",
        "par_data_vencimento_atual", "par_valor_original", "par_valor_atual", "par_status",
        "par_juros_adicionais", "par_valor_moeda", "par_valor_adicional", "par_liberada","par_valor_desconto_antecipacao",
        "par_data_alteracao", "par_fk_orq_codigo"];
    public $timestamps = false;

    protected $dates = [
        "par_data_vencimento_original",
        "par_data_vencimento_atual"
    ];

    //movimentação financeira

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function financial_moviment() {
        return $this->belongsTo(FinancialMovement::class, "par_fk_mvf_codigo");
    }
}