<?php


namespace Schaffen\Financial\FinancialMovement\Services;


use Schaffen\Financial\FinancialMovement\Repositories\FinancialMovementRepository;

class CalculationHandle
{
    /**
     * @param $installment
     * @param null $mvf
     * @return float
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     */
    public static function installmentTotal($installment, $mvf = null)
    {
        if (now()->lte($installment->par_data_vencimento_atual)) {
            return $installment->par_valor_atual;
        }
        if (empty($mvf)) {
            $mvf_repo = app()->make(FinancialMovementRepository::class);
            $mvf = $mvf_repo->find($installment->par_fk_mvf_codigo);
        }
        $total = $installment->par_valor_atual;
        $total += $installment->par_juros_adicionais + $installment->par_valor_moeda + $installment->par_valor_adicional;
        if (!empty($mvf->mvf_multa)) {
            $total += round((
                    $installment->par_valor_atual +
                    $installment->par_juros_adicionais +
                    $installment->par_valor_moeda +
                    $installment->par_valor_adicional
                ) * $mvf->mvf_multa / 100,2);
        }
        if (!empty($mvf->mvf_juros)) {
            $aux = $installment->par_valor_atual +
                $installment->par_juros_adicionais +
                $installment->par_valor_moeda +
                $installment->par_valor_adicional;
            if ($mvf->mvf_tipo_juros == 'S')
                $total += round(
                        ($aux ?? 0) *
                        (
                            1 + ($mvf->mvf_multa / 100) * now()->startOfDay()->diffInDays($installment->par_data_vencimento_atual)
                        ) - ($aux ?? 0),2);
            else
                $total += round(
                        ($aux ?? 0) *
                        (
                            pow(1 + ($mvf->mvf_juros / 100), now()->startOfDay()->diffInDays($installment->par_data_vencimento_atual))
                        ) - ($aux ?? 0),2);
        }

        return $total;
    }
}